//---------------------------------------------------------------------------------------------------------------------
//
// Project: PPRZOSD
//
// Component: ARMOSD Board
//
// Started: Mai 2009
//

//#define OLIMEXBOARD

#ifdef OLIMEXBOARD
#define TVSTANDARD 0x40 // 0=NTSC 0x40=PAL
#else
#define TVSTANDARD 0x40 // 0=NTSC 0x40=PAL
#endif


#define MAKE8(var,offset) (var >> (offset * 8)) & 0xFF
#define MAKE16(varhigh,varlow) ((varhigh & 0xFF)* 0x100) + (varlow & 0xFF)
#define MAKE32(var1,var2,var3,var4) ((unsigned long)var1<<24)+((unsigned long)var2<<16)+ ((unsigned long)var3<<8)+((unsigned long)var4) 

#include "LPC214x.h"                        /* LPC21xx definitions */
#include "target.h"
#include "type.h"
#include "ARMOSDBoard.h"
#include "irq.h"

#define UART0_SUPPORT
//#define UART0_RX_INT_MODE //no interrupt mode as a start
#include "uart.h"
#define BAUD           115200
#include "swi.h"
#include "timer.h"
#include <stdio.h>
#include "MAX7456_OSD.h"
//#include "uartISR.c"
#include "pprzparser.h"
#include "pprzmessages.h"

//--------------------------------------------------------------
// Toggle LED
int1 bLEDState = 0;
void toggleLED()
{
#ifndef OLIMEXBOARD
    if(bLEDState)
    	IOSET0 = (1<<LED1PIN);
    else
    	IOCLR0 = (1<<LED1PIN);

    bLEDState = !bLEDState;
#endif
    // restart the watchdog timer
       // restart_wdt();
}



static void delay(void )
{
	volatile int i,j;

	for (i=0;i<1000;i++)
		for (j=0;j<1000;j++);
}

// delay a bit
void Dly100us(void *arg)
{
	int delayTime = (int) arg;
	
	for(int i = 0; i < delayTime; ++i)
	{
		for(volatile int j = 0; j < 1000; ++j)
			;	
	}
		 	
}

void delay_ms(int ms){
	Dly100us(ms*10);
}

void init(void)
{ 
		//init_VIC();  
	    delay();
	    delay();
	    delay();
	    tvStandard=TVSTANDARD;
	    MAX7456_Init();
	    delay();
	    delay();
}

/*******************************************************************************
**   Main Function  main()
*******************************************************************************/
int main (void)
{

		unsigned char inc;
		char str[50];
		float temp;
		long itemp;
	    init();

	   	uart0Init(UART_BAUD(57600), UART_8N1, UART_FIFO_8); // setup the UART

	   	MAX7456_WriteString(8, 5,"PPRZ OSD V0.1",0);
	   	delay_ms(500);
	   	MAX7456_WriteString(8, 5,"             ",0);
	   	
	    	           
	   	while (TRUE)  // infinite Loop
	   	{
	   		if (messageAvailable){
	   			//sprintf(str,"last message : %d ",messageAvailable);
	   			//MAX7456_WriteString(8, 5,str,0);
	   			//sprintf(str,"errors : %d ",pprzl_error);
	   			//MAX7456_WriteString(8, 6,str,0);

	   			if(messageAvailable==DL_GPS){
	   				gps_message=pprzl_payload+2;
	   				sprintf(str,"%4d",(*gps_message).alt/100);
	   				MAX7456_WriteString(25, 5,str,0);
	   				MAX7456_WriteString(28, 6,"m",0);
	   				sprintf(str,"%3d.%02d ",(*gps_message).climb/100,abs((*gps_message).climb%100));
	   				MAX7456_WriteString(23, 7,str,0);
	   				MAX7456_WriteString(26, 8,"m/s",0);
	   				sprintf(str,"%3d",(*gps_message).speed/100);
	   				MAX7456_WriteString(1, 6,str,0);
	   				MAX7456_WriteString(1, 7,"m/s",0);
	   				sprintf(str,"%3d",(*gps_message).course/10);
	   				MAX7456_WriteString(13, 11,str,0);
	   				MAX7456_WriteString(13, 12,"HDG",0);
	   				if ((*gps_message).mode==0) MAX7456_WriteString(24, 1,"NOFIX",1);
	   					   				else MAX7456_WriteString(24, 1,"     ",0);
	   			}

	   			if(messageAvailable==DL_BARO_MS5534A){
	   				baro_ms5534a_message=pprzl_payload+2;
	   				sprintf(str,"%3d.%01d MPa",(*baro_ms5534a_message).pressure/100,((*baro_ms5534a_message).pressure%100)/10);  
	   				MAX7456_WriteString(1, 12,str,0);
	   			}

	   			if(messageAvailable==DL_SHT_STATUS){
	   				sht_status_message=pprzl_payload+2;
	   				itemp=(*sht_status_message).humid*10;
	   				sprintf(str,"%3d.%1d o/o",itemp/10,itemp%10);
	   				MAX7456_WriteString(1, 11,str,0);
	   				itemp=(*sht_status_message).temp*10;
	   				sprintf(str,"%3d.%1d C",itemp/10,itemp%10);
	   				MAX7456_WriteString(1, 10,str,0);
	   			}
	   			if(messageAvailable==DL_NAVIGATION){
	   				navigation_message=pprzl_payload+2;
	   				sprintf(str,"BLK%3u",(*navigation_message).cur_block);
	   				MAX7456_WriteString(8, 1,str,0);
	   				sprintf(str,"DIST%4.0f",sqrt((float)((*navigation_message).dist2_home)));
	   				MAX7456_WriteString(21, 0,str,0);
	   			}
	   			
	   			if(messageAvailable==DL_BAT){
	   				bat_message=pprzl_payload+2;
	   				sprintf(str,"PWR %3do/o",(((*bat_message).throttle)+0)/96);
	   				MAX7456_WriteString(19, 11,str,0);
	   				sprintf(str,"BAT  %2d.%1dV",(*bat_message).voltage/10,(*bat_message).voltage%10);
	   				MAX7456_WriteString(19, 12,str,0);
	   				sprintf(str,"%5ds",(*bat_message).flighttime);
	   				MAX7456_WriteString(1, 0,str,0);
	   			}
	   			
	   			if(messageAvailable==DL_FBW_STATUS){
	   				fbw_status_message=pprzl_payload+2;
	   				if ((*fbw_status_message).rc_status!=0) MAX7456_WriteString(24, 2,"NORC",1);
	   				else MAX7456_WriteString(24, 1,"    ",0);
	   			}
	   			if(messageAvailable==DL_PPRZ_MODE){
	   				pprz_mode_message=pprzl_payload+2;
	   				if ((*pprz_mode_message).ap_mode==0) MAX7456_WriteString(1, 1,"MANUAL",0);
	   				if ((*pprz_mode_message).ap_mode==1) MAX7456_WriteString(1, 1,"AUTO1 ",1);
	   				if ((*pprz_mode_message).ap_mode==2) MAX7456_WriteString(1, 1,"AUTO2 ",1);
	   			}
	   			toggleLED();
	   			messageAvailable=0;
	   		}
	   	 if (U0LSR & ULSR_RDR)
	   	        {
	   				inc = U0RBR;
	   				uart0Putch(inc);
	   	#ifdef LOG_XBEE
	   	            log_xbee(inc, LOG_SOURCE_UART0);
	   	#else
	   	#ifdef LOG_PPRZ
	   	            log_pprz(inc, LOG_SOURCE_UART0);
	   	#else
	   	#error no log transport protocol selected
	   	#endif
	   	#endif
	   	        }
		}
      
    
    return 0;
}
/******************************************************************************
**                            End Of File
******************************************************************************/
