//---------------------------------------------------------------------------------------------------------------------
//
// Project: PPRZOSD
//
// Component: ARMOSD Board
//
// Started: Mai 2009
//
 /*   This collects telemetry received through a serial port displays it
 */


struct dl_gps {
		unsigned char mode;
		signed long utm_east;
		signed long utm_north;
		signed short course;
		signed long alt;
		unsigned short speed;
		signed short climb;
		unsigned long itow;
		unsigned char utm_zone;
		unsigned char gps_nb_err;
} __attribute__((packed));

struct dl_baro_ms5534a {
		unsigned long pressure;
		unsigned short temp;
		float alt;
} __attribute__((packed));

struct dl_sht_status {
		unsigned short ihumid;
		unsigned short itemp;
		float humid;
		float temp;
} __attribute__((packed));

struct dl_navigation {
		unsigned char  cur_block;
		unsigned char cur_stage;
		signed short pos_x;
		signed short pos_y;
		float dist2_wp;
		float dist2_home;
} __attribute__((packed));

struct dl_bat {
		signed short throttle;
		unsigned char voltage;
		unsigned short flighttime;
		unsigned char kill_auto_throttle;
		unsigned short block_time;
		unsigned short stage_time;
		unsigned short energy;
} __attribute__((packed));

struct dl_fbw_status {
		unsigned char rc_status;
		unsigned char mode;
		unsigned char vsupply;
		unsigned short current;
} __attribute__((packed));

struct dl_pprz_mode {
		unsigned char ap_mode;
		unsigned char ap_gaz;
		unsigned char ap_lateral;
		unsigned char ap_horizontal;
		unsigned char if_calib_mode;
		unsigned char mcu1_status;
} __attribute__((packed));

struct dl_gps *gps_message;
struct dl_baro_ms5534a *baro_ms5534a_message;
struct dl_sht_status *sht_status_message;
struct dl_navigation *navigation_message;
struct dl_bat *bat_message;
struct dl_fbw_status *fbw_status_message;
struct dl_pprz_mode *pprz_mode_message;

//Messages IDs

#define DL_BOOT 1
#define DL_ALIVE 2
#define DL_PONG 3
#define DL_TAKEOFF 4
#define DL_DebugChao 5
#define DL_ATTITUDE 6
#define DL_IR_SENSORS 7
#define DL_GPS 8
#define DL_NAVIGATION_REF 9
#define DL_NAVIGATION 10
#define DL_PPRZ_MODE 11
#define DL_BAT 12
#define DL_DEBUG_MCU_LINK 13
#define DL_CALIBRATION 14
#define DL_SETTINGS 15
#define DL_DESIRED 16
#define DL_GPS_SOL 17
#define DL_ADC_GENERIC 18
#define DL_CAM 20
#define DL_CIRCLE 21
#define DL_SEGMENT 22
#define DL_DOWNLINK_STATUS 23
#define DL_MODEM_STATUS 24
#define DL_SVINFO 25
#define DL_SURVEY 27
#define DL_WC_RSSI 28
#define DL_RANGEFINDER 29
#define DL_DOWNLINK 30
#define DL_DL_VALUE 31
#define DL_MARK 32
#define DL_WP_MOVED 35
#define DL_GYRO_RATES 36
#define DL_SPEED_LOOP 40
#define DL_ALT_KALMAN 41
#define DL_ESTIMATOR 42
#define DL_TUNE_ROLL 43
#define DL_BARO_MS5534A 44
#define DL_AIRSPEED 45
#define DL_BARO_WORDS 46
#define DL_WP_MOVED_LLA 47
#define DL_WP_MOVED_LTP 49
#define DL_CHRONO 48
#define DL_PPM 100
#define DL_RC 101
#define DL_COMMANDS 102
#define DL_FBW_STATUS 103
#define DL_ADC 104
#define DL_ACTUATORS 105
#define DL_DC_SHOT 110
#define DL_TCAS_TA 120
#define DL_TCAS_RA 121
#define DL_TCAS_DEBUG 122
#define DL_IMU_GYRO 200
#define DL_IMU_MAG 201
#define DL_IMU_ACCEL 202
#define DL_IMU_GYRO_RAW 203
#define DL_IMU_ACCEL_RAW 204
#define DL_IMU_MAG_RAW 205
#define DL_IMU_GYRO_RAW_AVG 206
#define DL_IMU_ACCEL_RAW_AVG 207
#define DL_IMU_MAG_RAW_AVG 208
#define DL_IMU_GYRO_LP 209
#define DL_IMU_PRESSURE 210
#define DL_IMU_DEBUG 211
#define DL_IMU_TURNTABLE 220
#define DL_TIME 227
#define DL_QUAD_INS 228
#define DL_QUAD_STATUS 229
#define DL_BOOZ_STATUS 231
#define DL_BOOZ_SIM_RPMS 239
#define DL_BOOZ_SIM_SPEED_POS 240
#define DL_BOOZ_SIM_RATE_ATTITUDE 241
#define DL_BOOZ_SIM_GYRO_BIAS 242
#define DL_BOOZ_SIM_RANGE_METER 243
#define DL_BOOZ_SIM_WIND 244
#define DL_BOOZ_DEBUG_FOO 245
#define DL_BOOZ_MAX1167_ERR 246
#define DL_BOOZ_ERROR 247
#define DL_BOOZ_SIM_ACCEL_LTP 248
#define DL_VF_UPDATE 76
#define DL_VF_PREDICT 77
#define DL_CROSS_TRACK_ERROR 80
#define DL_ESTIMATOR_COMP_FILTER 81
#define DL_FORMATION_SLOT_TM 82
#define DL_FORMATION_STATUS_TM 83
#define DL_WIND_INFO_RET 87
#define DL_SCP_STATUS 88
#define DL_SHT_STATUS 89
#define DL_ENOSE_STATUS 90
#define DL_DPICCO_STATUS 91
#define DL_ANTENNA_DEBUG 92
#define DL_ANTENNA_STATUS 93
#define DL_MOTOR_BENCH_STATUS 94
#define DL_MOTOR_BENCH_STATIC 95
#define DL_BOOZ2_STABILIZATION 130
#define DL_BOOZ2_GYRO 131
#define DL_BOOZ2_ACCEL 132
#define DL_BOOZ2_MAG 133
#define DL_BOOZ2_FILTER 134
#define DL_BOOZ2_FILTER2 135
#define DL_BOOZ2_RATE_LOOP 136
#define DL_BOOZ2_FILTER_ALIGNER 137
#define DL_BOOZ2_FILTER_Q 138
#define DL_BOOZ2_FILTER_COR 139
#define DL_BOOZ2_STAB_ATTITUDE 140
#define DL_BOOZ2_STAB_ATTITUDE_REF 141
#define DL_BOOZ2_STAB_ATTITUDE_HS_ROLL 142
#define DL_BOOZ2_CMD 143
#define DL_BOOZ2_GUIDANCE 144
#define DL_BOOZ2_VERT_LOOP 145
#define DL_BOOZ2_HOVER_LOOP 146
#define DL_BOOZ2_FP 147
#define DL_BOOZ2_FMS_INFO 148
#define DL_BOOZ2_NAV_REF 149
#define DL_BOOZ2_TUNE_HOVER 150
#define DL_BOOZ2_INS 151
#define DL_BOOZ2_INS2 152
#define DL_BOOZ2_INS3 153
#define DL_BOOZ2_INS_REF 154
#define DL_BOOZ2_GPS 155
#define DL_BOOZ2_AHRS_EULER 156
#define DL_BOOZ2_AHRS_QUAT 157
#define DL_BOOZ2_AHRS_RMAT 158
#define DL_BOOZ2_NAV_STATUS 159
#define DL_AHRS_EULER 160
#define DL_AHRS_MEASUREMENT_EULER 161
#define DL_WT 175
#define DL_CSC_CAN_DEBUG 176
#define DL_CSC_CAN_MSG 177
#define DL_FMS_TIME 180
#define DL_WHIRLY_CONTROL 181
#define DL_WHIRLY_ESTIMATOR 182
#define DL_WHIRLY_MOTORCONTROL 183
#define DL_WHIRLY_STATUS 184
#define DL_WHIRLY_IMU 185
#define DL_WHIRLY_IMU_RAW 186
#define DL_WHIRLY_KALMAN_DEBUG 187
#define DL_WHIRLY_ESTIMATOR_DEBUG 188
#define DL_MSG_telemetry_NB 138
