//---------------------------------------------------------------------------------------------------------------------
//
// Project: ARMOSD
//
// Component: ARMOSD Board
//
// Started: September 2008
//
// Warning: No portion of the code used in this project may be distributed without the permission of all of the team members:
//          Didier Jaillant, Rolf Ziegler, Anthony Cake, Cedric Marzer

// playsound

#include "ready.h"

int playsoundcounter;
	
void  playsoundTimer0Handler (void) __irq
	{  
		unsigned long dac_value;
	    T0IR = 1;			/* clear interrupt flag */
	    IENABLE;			/* handles nested interrupt */
	    if (playsoundcounter<ready_raw_len){	    	
	    	DACR = (ready_raw[playsoundcounter]*4 << 6) | DAC_BIAS;
	    	playsoundcounter++;
	    }
	    else playsoundcounter=0;
	    
	    
	    IDISABLE;
	        VICVectAddr = 0;		/* Acknowledge Interrupt */
	    }

void playsoundinit(){
	PINSEL1 = 0x00080000;	/* set p0.25 to DAC output */
	//init timer
	 T0MR0 = 1562;	/* the magic number for 8kHz */
	 T0MCR = 3;			/* Interrupt and Reset on MR0 */
	 install_irq( TIMER0_INT, (void *)playsoundTimer0Handler) ;
	 enable_timer( 0 );
	 playsoundcounter=0;
}
	
void test_playsound(){
	playsoundinit();
	while(1){}
}